class Agent {
  
  //xD and yD are the coordinates of the direction. 
  //xF and yF follow this direction.
  int xD,yD,xF,yF, life, a;
  float newDir, oldDir; 
  color clr;
  
  Agent() { }
  
  Agent(int x, int y, color c, int l) {
    xF = x;
    yF = y;
    clr = c;
    life = l;
    a = 2;
  }
  
  void update() {
    // New direction lies within a margin of the old direction, 
    // thus creating a smooth path.
    newDir = random(-PI/5+oldDir,PI/5+oldDir); 
    xD = (int)(50 * cos(newDir));
    yD = (int)(50 * sin(newDir));
    xF = xF + xD/10;
    yF = yF + yD/10;
    
    // Limit an agent's freedom of movement to the screen width and height.
    if (xF > width) { xF = width;}
    if (xF < 0) { xF = 0;}
    if (yF > height) { yF = height;}
    if (yF < 0) { yF = 0;}
    
    stroke(clr,a*2);
    fill(clr,0); // No fill for the outer circles.
    int r = (int)random(10,200);
    ellipse(xF+random(30), yF+random(30), r, r);
    
    stroke(clr,a*5);
    fill(clr,a/2); // A slight fill color for the bubbles.
    r = (int)random(1,20);
    ellipse(xF+random(30), yF+random(30), r, r);
    oldDir = newDir;
    life--; // Placing a bubble, will shorten its life.
  }
}
